/*-----------------------------------------------------------
 ($B%W%m%0%i%`L>(B)
 calcUpperArea.cc

 ($B$3$N%W%m%0%i%`$,$9$k$3$H(B)
 $B3F%*%V%8%'%/%H$N>eN.0hLL@Q$r7W;;$9$k!#(B

 ($BF~NO%U%!%$%k(B)
 $B!&%$%s%G%C%/%9%U%!%$%k(B (makeSubConnect $B$N=PNO%U%!%$%k(B)
 $B!&%*%V%8%'%/%H4V@\B3>pJs%U%!%$%k(B (makeGridConnect $B$N=PNO%U%!%$%k(B)
 $B!&%Q%i%a!<%?%U%!%$%k(B (makePmtFile $B$N=PNO%U%!%$%k(B)

 ($B=PNO%U%!%$%k(B)
 $B!&3F%*%V%8%'%/%H$N>eN.0hLL@Q$r5-$7$?%U%!%$%k(B

 ($B%"%k%4%j%:%`(B)

 $B>eN.B&$N%*%V%8%'%/%H$,2<N.B&$K@\B3$7$F$$$k%*%V%8%'%/%H$K<+J,$,(B
 $BM-$7$F$$$k>eN.0hLL@Q$rEO$9$3$H$G3F%*%V%8%'%/%H$N>eN.0hLL@Q$r7W(B
 $B;;$7$F$$$/!#2<N.B&$K@\B3$9$k%*%V%8%'%/%H$,J#?t$"$k>l9g$O6QEy$K(B
 $BJ,G[$7EO$9!#:G>eN.$K0LCV$9$k%*%V%8%'%/%H$+$i=g$KLL@Q$rEO$7$F$$(B
 $B$/$,!"LL@Q<uEO$7$N=g=x$O3F%*%V%8%'%/%H$K%$%K%7%c%k%l%Y%k(B (IL) 
 $B$rIU$1$k$3$H$G7hDj$9$k!#(BIL $B$H$OG$0U$N%*%V%8%'%/%H$,:G>eN.$N%*%V(B
 $B%8%'%/%H$+$i?t$($F2?HVL\$N%0%k!<%W$K0LCV$9$k$+$rI=$9CM$G$"$k!#(B
 $B2<$K<($9?^$G$O!"(BA, E $B$N(B IL = 0 $B$G$"$j!"(BB, C $B$N(B IL = 1 $B$G$"$j!"(BD 
 $B$N(B IL = 2 $B$G$"$j!"(BF $B$N(B IL = 3 $B$G$"$k!#(B 

              E
             $B"-(B
    A $B"*(B B $B"*(B D $B"*(B F
   $B"-(B        $B",(B
    C $B"*(B $B"*(B $B"*(B

 $B$3$l$K=>$$LL@Q$N<uEO$7$O!"(B
 $B$^$:!"(B
    A $B"*(B B, A $B"*(B C, E $B"*(B D
 $B<!$K!"(B
    B $B"*(B D, C $B"*(B D  
 $B:G8e$K!"(B
    D $B"*(B F
 $B$N=g$G9T$J$&!#(BIL $B$H$$$&35G0$rMQ$$$k$3$H$G!"Nc$($P(B B $B"*(B D $B$r9T$J(B
 $B$&A0$K(B D $B"*(B F $B$r9T$J$&$H$$$C$?$3$H$rKI$0$3$H$,$G$-$k!#(B

 -----------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv)
{
	char idx_file[256];
	char connect_file[256];
	char pmt_file[256];
	char output_file[256];

	if(argc != 1 && argc != 5){
		printf("Usage : calcUpperArea ");
		printf("connectFileName indexFileName outputFileName \n");
		exit(1);
	}

	if(argc == 1){
		printf("# connectFileName : ");
		scanf("%s",connect_file);
		printf("# indexFileName : ");
		scanf("%s",idx_file);
		printf("# parameterFileName : ");
		scanf("%s",pmt_file);
		printf("# outputFileName : ");
		scanf("%s",output_file);
	}

	else{
		sscanf(argv[1], "%s", connect_file);
		sscanf(argv[2], "%s", idx_file);
		sscanf(argv[3], "%s", pmt_file);
		sscanf(argv[4], "%s", output_file);
	}

	FILE* fp_connect;
	FILE* fp_idx;
	FILE* fp_pmt;
	FILE* fp_out;

	char buf[256];

	//------$B%*%V%8%'%/%H?t$r%+%&%s%H(B---------

	if((fp_idx = fopen(idx_file,"r")) == NULL){
		printf("cannot open index file \n");
		exit(1);
	}
	int counter = 0;
	char ob_name[100];
  	while(fgets(buf, 256, fp_idx) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
    	else {
      		if (sscanf(buf, "%s", ob_name) != 1){
				printf("Cannot scan object name.\n");
				exit(1);
			}
			counter++;
		}
	}
	fclose(fp_idx);

	int Num_of_obj;
	Num_of_obj = counter;
	printf("Number of object = %d\n", Num_of_obj);

	//------object$BL>$rF~$l$kG[Ns$rMQ0U$7$F3JG<(B--------

	int i, j, k = 0;
	char** obj_name;

	obj_name = new char*[Num_of_obj];
	for(i = 0; i < Num_of_obj; i++){
		obj_name[i] = new char[100];
	}

	if((fp_idx = fopen(idx_file,"r")) == NULL){
		printf("cannot open index file \n");
		exit(1);
	}
	while(fgets(buf, 256, fp_idx) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;

		if(sscanf(buf, "%s", ob_name) != 1){
			printf("cannot scan object from index file. \n");
			exit(1);
		}					
		else{
			strcpy(obj_name[k], ob_name);
			k++;
		}
	} 
	fclose(fp_idx);


	//-------$B@\B39TNs$rMQ0U$7$F!"CM$r3JG<(B--------

	int** matrix;
	matrix = new int*[Num_of_obj];
	for(i = 0; i < Num_of_obj; i++){
		matrix[i] = new int[Num_of_obj];
	}
	for(i = 0; i < Num_of_obj; i++){
		for(j = 0; j < Num_of_obj; j++){
			matrix[i][j] = 0;
		}
	}

    // $B@\B39TNs$KCM$r3JG<$9$k!#(B
	if((fp_connect = fopen(connect_file, "r")) == NULL){
		printf("Cannot open '%s'.\n", connect_file);
		exit(1);
	}

	char d_obname[50], u_obname[50];
	int rp_no, sp_no;
	int X, Y;
	while(fgets(buf, 256, fp_connect) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
		else{
			if(sscanf(buf, "%s %d %s %d", d_obname, &rp_no, u_obname, &sp_no)
			   != 4){
				printf("Cannot scan connect data.\n");
				exit(1);
			}
			for(i = 0; i < Num_of_obj; i++){
				if(strcmp(obj_name[i], u_obname) == 0){
					X = i;
					break;
				}
			}
			for(i = 0; i < Num_of_obj; i++){
				if(strcmp(obj_name[i], d_obname) == 0){
					Y = i;
					break;
				}
			}
			matrix[X][Y] = 1;
		}
	}
	fclose(fp_connect);

	//$B<PLLMWAG%b%G%kL>$rG[Ns$K3JG<(B
	char subFname[256], slopeObjName[256];
	int n1, n2, n3, n4, n5, n6;

	if((fp_idx = fopen(idx_file,"r")) == NULL){
		printf("cannot open index file \n");
		exit(1);
	}

	char** slopeEleName;
	slopeEleName = new char*[Num_of_obj];
	for(i = 0; i < Num_of_obj; i++){
		slopeEleName[i] = new char[100];
	}
	k = 0;
	while(fgets(buf, 256, fp_idx) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
		if(sscanf(buf, "%s %d %d %d %d %s %d %d %s", &ob_name,
				  &n1, &n2, &n3, &n4, &subFname, &n5, &n6,
				  &slopeObjName) != 9){
			printf("cannot scan object from index file. \n");
			exit(1);
		}					
		else{
			strcpy(slopeEleName[k], slopeObjName);
			k++;
		}
	}
	fclose(fp_idx);
	
	//$B3F%*%V%8%'%/%H$NLL@Q$rG[Ns$K3JG<(B
	if((fp_pmt = fopen(pmt_file,"r")) == NULL){
		printf("cannot open pmt file \n");
		exit(1);
	}

	char Model_name[256], ElementName[256];
	int tempNo;

	float Ai, b, Wm, Kg, area;
	float obj_area[Num_of_obj];

	for(i = 0; i < Num_of_obj; i++){
		obj_area[i] = 0;
	}

	while(fgets(buf, 256, fp_pmt) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
		if(sscanf(buf, "%s %s %d", &Model_name, &ElementName,
				  &tempNo) == 3){
			for(i = 0; i < Num_of_obj; i++){
				if(strcmp(ElementName, slopeEleName[i]) == 0){
					fgets(buf, 256, fp_pmt);
					if(sscanf(buf, "%f %f %f %f %f", &Ai, &b,
							  &Wm, &Kg, &area) != 5){
						printf("pmt file is wrong.\n");
						exit(1);
					}
					else{
						obj_area[i] = area;
					}
				}
			}
		}
	}
	fclose(fp_pmt);

	//$B3F%*%V%8%'%/%H$N%$%K%7%c%k%l%Y%k$r7h$a$k!#(B

	int IL[Num_of_obj], current_uppestObj[Num_of_obj];
	for(i = 0; i < Num_of_obj; i++){
		IL[i] = -1;
		current_uppestObj[i] = -1;
	}

	int current_IL = 0, flag, flag_a, flag_b, last_level;
	int m, n;

	while(1){
		printf("*******current IL is %d*******\n", current_IL);
		k = 0;
		flag = 0;
		for(j = 0; j < Num_of_obj; j++){
			flag_a = 0;
			flag_b = 0;
			for(i = 0; i < Num_of_obj; i++){
				if(matrix[i][j] == 1) flag_a = 1;
				if(matrix[i][j] == 0) flag_b = 1;
			}

			//$B=DJ}8~$NMWAG$K(B 1 $B$,4^$^$l$F$$$k%*%V%8%'%/%H$OL5;k(B
			//$B$9$k!#(B
			if(flag_a == 1) continue;

			//$B=DJ}8~MWAG$,A4$F(B 2 $B$N%*%V%8%'%/%H$OL5;k$9$k!#(B
			if(flag_b == 0) continue; 

			else{
				current_uppestObj[k] = j;
				//$B=DJ}8~$NMWAG$K(B 1 $B$,4^$^$l$F$$$J$$%*%V%8%'%/%H(B
				//$B$N(B IL $B$,7hDj$5$l$k!#(B
				IL[j] = current_IL;
				printf("***IL of %s is %d***\n", obj_name[j],
					   IL[j]);
				k++;
			}
		}

		// $B@\B39TNs$K$*$$$F!":#2s(B IL $B$,7hDj$5$l$?%*%V%8%'%/%H$N(B
		// $B=D$H2#$NMWAG$KA4$F(B 2 $B$rF~$l$k!#(B

		for(n = 0; n < k; n++){
			for(i = 0; i < Num_of_obj; i++){
				matrix[i][current_uppestObj[n]] = 2;
			}
		}
		for(m = 0; m < k; m++){
			for(j = 0; j < Num_of_obj; j++){
				matrix[current_uppestObj[m]][j] = 2;
			}
		}

		// $B@\B39TNs$NMWAG$,A4$F(B 2 $B$K$J$C$?$+$rD4$Y$k!#(B

		for(j = 0; j < Num_of_obj; j++){
			for(i = 0; i < Num_of_obj; i++){
				if(matrix[i][j] != 2) flag = 1;
			}
		}
		if(flag == 0){
			last_level = current_IL;
			printf("last level is %d\n", last_level);
			break; //$BMWAG$,A4$F(B2$B$K$J$C$?$N$G=*N;!#(B
		}
		else current_IL++;
	}


	// IL $B$,(B -1 $B$N%*%V%8%'%/%H$,;D$C$F$$$J$$$+3NG'$9$k!#(B
	for(i = 0; i < Num_of_obj; i++){
		if(IL[i] == -1){
			printf("initial level of %s has not been decided.\n",
				   obj_name[i]);
			exit(1);
		}
	}

	//$B@\B39TNs$K85$NCM$r3JG<$7$J$*$9!#(B

	for(i = 0; i < Num_of_obj; i++){
		matrix[i] = new int[Num_of_obj];
	}
	for(i = 0; i < Num_of_obj; i++){
		for(j = 0; j < Num_of_obj; j++){
			matrix[i][j] = 0;
		}
	}
	if((fp_connect = fopen(connect_file, "r")) == NULL){
		printf("Cannot open '%s'.\n", connect_file);
		exit(1);
	}
	while(fgets(buf, 256, fp_connect) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
		else{
			if(sscanf(buf, "%s %d %s %d", d_obname, &rp_no, u_obname, &sp_no)
			   != 4){
				printf("Cannot scan connect data.\n");
				exit(1);
			}
			for(i = 0; i < Num_of_obj; i++){
				if(strcmp(obj_name[i], u_obname) == 0){
					X = i;
					break;
				}
			}
			for(i = 0; i < Num_of_obj; i++){
				if(strcmp(obj_name[i], d_obname) == 0){
					Y = i;
					break;
				}
			}
			matrix[X][Y] = 1;
		}
	}
	fclose(fp_connect);

	// $B3F%*%V%8%'%/%H$N>eN.0hLL@Q$r7W;;$7$$$F$$$/!#(B

	float upper_area[Num_of_obj];
	for(i = 0; i < Num_of_obj; i++){
		//$B:G=i$O3F%*%V%8%'%/%H<+?H$NLL@Q$r!"$=$N%*%V%8%'%/%H$N>e(B
		//$BN.0hLL@Q$H$7$F$*$/!#(B
		upper_area[i] = obj_area[i]; 
	}
	int now_level = 0, flag_L;
	int low_objNo[Num_of_obj];

	while(now_level <= last_level){
		for(i = 0; i < Num_of_obj; i++){
			if(IL[i] == now_level){
				m = 0;
				for(n = 0; n < Num_of_obj; n++){
					low_objNo[n] = -1;
				}

				// $BCeL\$7$F$$$k%*%V%8%'%/%H$ND>2<$K0LCV$9$k%*%V(B
				// $B%8%'%/%H$rD4$Y$k!#(B
				for(k = 0; k < Num_of_obj; k++){
					if(matrix[i][k] == 1){
						low_objNo[m] = k;
						m++;
					}
				}
				// $BCeL\$7$F$$$k%*%V%8%'%/%H$N>eN.0hLL@Q$rD>2<$K(B
				//$B0LCV$9$k%*%V%8%'%/%H$KEO$9!#(B
				for(j = 0; j < m; j++){
					printf("now %s is transported to %s\n",
						   obj_name[i], obj_name[low_objNo[j]]);
					upper_area[low_objNo[j]] += (upper_area[i]/m);
				}
			}
		}
		now_level++;
		if(now_level > last_level) break;
	}

	//$B3F%*%V%8%'%/%H$N>eN.0hLL@Q$r%U%!%$%k$K=PNO$9$k!#(B

	if((fp_out = fopen(output_file, "w")) == NULL){
		printf("Cannot open output_file.\n");
		exit(1);
	}
	for(i = 0; i < Num_of_obj; i++){
		fprintf(fp_out, "%s %f\n", obj_name[i], upper_area[i]);
	}
	fclose(fp_out);
}
